> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# List kubernetes cluster workload reports

> Returns a paginated list of workload container right-sizing reports for the cluster, with recommendations, cost and savings, for the tenant selected by the X-CostGraph-Tenant-ID header



## OpenAPI

````yaml /api-reference/costgraph/openapi.json get /api/v1/tenant/clusters/{cluster_id}/workloads
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: infracost
    x-group: Infracost
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: service-map
    x-group: Service map
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/tenant/clusters/{cluster_id}/workloads:
    get:
      tags:
        - kubernetes-clusters
      summary: List kubernetes cluster workload reports
      description: >-
        Returns a paginated list of workload container right-sizing reports for
        the cluster, with recommendations, cost and savings, for the tenant
        selected by the X-CostGraph-Tenant-ID header
      parameters:
        - description: Tenant ID
          name: X-CostGraph-Tenant-ID
          in: header
          required: true
          schema:
            type: string
        - description: Kubernetes cluster ID
          name: cluster_id
          in: path
          required: true
          schema:
            type: string
        - description: Filter by workload name
          name: workload
          in: query
          explode: true
          schema:
            type: array
            items:
              type: string
        - description: Filter by namespace name
          name: namespace
          in: query
          explode: true
          schema:
            type: array
            items:
              type: string
        - description: Filter by resource (cpu, memory)
          name: resource
          in: query
          explode: true
          schema:
            type: array
            items:
              type: string
        - description: Filter by recommended action
          name: action
          in: query
          explode: true
          schema:
            type: array
            items:
              type: string
        - description: Filter by urgency
          name: urgency
          in: query
          explode: true
          schema:
            type: array
            items:
              type: string
        - description: Search by container or workload name
          name: search
          in: query
          schema:
            type: string
        - description: >-
            Sort column: savings, current_cost, recommended_cost,
            current_cost_per_hour, container_count, updated or name. Prefix with
            - for descending. Default -savings
          name: sort
          in: query
          schema:
            type: string
        - description: Maximum number of reports to return
          name: limit
          in: query
          schema:
            type: integer
        - description: Number of reports to skip
          name: offset
          in: query
          schema:
            type: integer
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/responses.SuccessResponse'
                  - type: object
                    properties:
                      data:
                        $ref: '#/components/schemas/k8scluster.WorkloadsListResult'
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
      security:
        - BearerAuth: []
components:
  schemas:
    responses.SuccessResponse:
      type: object
      required:
        - message
        - status
      properties:
        data: {}
        message:
          type: string
          example: some message
        status:
          type: string
          example: success
    k8scluster.WorkloadsListResult:
      type: object
      required:
        - items
        - limit
        - offset
        - total_count
        - workloads_aggregate
      properties:
        items:
          type: array
          items:
            $ref: '#/components/schemas/k8scluster.WorkloadsItem'
        limit:
          type: integer
        offset:
          type: integer
        total_count:
          type: integer
        workloads_aggregate:
          $ref: '#/components/schemas/k8scluster.WorkloadsAggregate'
    responses.ErrorResponse:
      type: object
      required:
        - message
        - status
      properties:
        message:
          type: string
          example: some message
        status:
          type: string
          example: error
    k8scluster.WorkloadsItem:
      type: object
      required:
        - action
        - api_version
        - container_count
        - currency
        - current_cost
        - current_cost_per_hour
        - kind
        - namespace
        - resource
        - resource_id
        - urgency
        - workload_name
      properties:
        action:
          type: string
        api_version:
          type: string
        container_count:
          type: integer
        currency:
          type: string
        current_cost:
          type: number
        current_cost_per_hour:
          type: number
        kind:
          type: string
        namespace:
          type: string
        recommended_cost:
          description: or null, for no recommendation
          type: number
          nullable: true
        resource:
          type: string
        resource_id:
          type: string
        savings_per_month:
          description: or null, for no recommendation
          type: number
          nullable: true
        urgency:
          type: string
        workload_name:
          type: string
    k8scluster.WorkloadsAggregate:
      type: object
      required:
        - total_current_cost
        - total_monthly_savings
        - total_recommendations
        - total_recommended_cost
        - workloads_with_recs
      properties:
        total_current_cost:
          type: number
        total_monthly_savings:
          type: number
        total_recommendations:
          type: integer
        total_recommended_cost:
          type: number
        workloads_with_recs:
          type: integer
  securitySchemes:
    BearerAuth:
      description: Enter "Bearer {token}"
      type: apiKey
      name: Authorization
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.